package com.iden.bms.init;



import com.iden.bms.service.FaceIdenService;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.CommandLineRunner;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;


@Component
@Order(3)
public class FaceMonitorInit implements CommandLineRunner {

    private static final Logger logger = LogManager.getLogger(FaceMonitorInit.class);

    @Resource
    private FaceIdenService faceIdenService;

    @Value("${init.face.dataset:#{null}}")
    private String initFaceDataset;


    @Override
    public void run(String... args) throws Exception {
        if("1".equals(initFaceDataset)){
            logger.info("初始化人脸识别库 start ...........................");
            faceIdenService.initFaceDataset();
            logger.info("初始化人脸识别库 end ...........................");
        }

    }

}

